#include "constants.fxh"

struct vs_in_show {
	float3 Pos  : POSITION;
	float2 Tex0 : TEXCOORD0;
};
struct vs_out {
	float4 Pos: POSITION;
	float2  Tex0: TEXCOORD0;
};

sampler2D ShowSampler = sampler_state {
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
};

vs_out VS_main(vs_in_show In)
{
  vs_out Out;
  
  float3 Pos = In.Pos + C_Eye.xyz;
	Out.Pos = mul(mul(float4(Pos,1), PI_mW), C_VP);
	Out.Tex0 = In.Tex0;
	
	return Out;
}

half4 PS_main(vs_out In) : COLOR0
{
	float4 Col = tex2D(ShowSampler, In.Tex0);// * 5.0f;
 	//return half4(0, 1, 0, 1);	// return pure green as error
 	
 	return Col;
}

technique Default
{
	pass p0 
	{		
		VertexShader = compile VS_SHADER_TYPE VS_main();
		PixelShader = compile PS_SHADER_TYPE PS_main();
		DEFAULT_STATES
	}
}

