#define fragInput vertexOutput
#define RT_TEX_SCROLL
#define FRAG_CUSTOM_END

#include "transform.fxh"
#include "fragDef.fxh"

void frag_custom_per_light(inout fragPass pPass, inout fragLightPass pLight)
{
}

void frag_custom_end(inout fragPass pPass, inout FIXED3 cFinal)
{
  half3 cDiffuse = pPass.cDiffuseMap.xyz * pPass.cVertexColor.rgb;
	//cDiffuse *= materialColor.rgb;

  cFinal.rgb += cDiffuse;

#if defined(RT_FOG)	// disable fog for blending
	pPass.IN.FogColor.xyz = 0;
	cFinal.rgb *= pPass.IN.FogColor.a;
	pPass.IN.FogColor.a = 1.h;
#endif
}

#include "fragLib.fxh"

half4 PS_Fire(const in fragInput IN) : COLOR
{
  // Initialize fragPass structure
  fragPass pPass;
#ifndef OPENGL
  pPass = (fragPass)0;
#endif
  frag_unify(pPass, IN);  
  half4 cFinal = frag_shared_output(pPass);
  //cFinal.w = fOpacity;
	return cFinal;
}

technique Fire < string name = "Material fire."; >
{
  pass p0
  {
    VertexShader = compile VS_SHADER_TYPE UberVS();
    PixelShader = compile PS_SHADER_TYPE PS_Fire();
		DEFAULT_STATES
  }
}
