/*
	GEOverlay
*/

#include "fragDef.fxh"
#include "Transform.fxh"

//=========================================================================================================

uniform float4 vpsParams = float4(1.f, 0.f, 0.f, 0.f);

struct vs_in {
	float3 Pos: POSITION;
	float2 Tex0: TEXCOORD0;
};

struct vs_out {
	float4 Pos: POSITION;
	float2  Tex0: TEXCOORD0;
};

sampler2D sampler0 = sampler_state
{
    Texture = <Texture0>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};
//===========================================================================================

vs_out VSShow(vs_in In)
{
	vs_out Out;
	Out.Pos = float4(In.Pos.xyz, 1);
#ifdef OPENGL
  Out.Pos.xy = ((Out.Pos.xy+float2(0.5, 0.5)) * F_ScreenSize.xy) * 2.f - 1.f;
#endif  
	Out.Tex0 = In.Tex0;
	return Out;
}

float4 PSShow(vs_out In): COLOR
{
	float4 Col = tex2D(sampler0, In.Tex0).a;
	
	return Col;
}
float4 PSOverlay(vs_out In): COLOR
{
	float4 Col = tex2D(sampler0, In.Tex0);
	
	return Col;
}

technique TShow
{
	pass p0 
	{
		VertexShader = compile VS_SHADER_TYPE VSShow();
		PixelShader  = compile PS_SHADER_TYPE PSShow();
	}
}

technique TOverlay
{
	pass p0 
	{
		VertexShader = compile VS_SHADER_TYPE VSShow();
		PixelShader  = compile PS_SHADER_TYPE PSOverlay();

    ZEnable = false;
#ifdef OGL
		CullMode = FrontAndBack;
    BlendEnable = true;
    BlendFunc = { SrcAlpha, InvSrcAlpha };
#else
		CullMode = none;
    AlphaBlendEnable = true;
    SrcBlend = SrcAlpha;
    DestBlend = InvSrcAlpha;
#endif
	}
}
