#include "constants.fxh"

struct VpIn20
{
	float4 Pos				: POSITION;
	float3 TexCoord0 	: TEXCOORD0;
};

struct VpOut20
{
	float4 HPos       : POSITION; 
	float2 TexCoord0  : TEXCOORD0;
	float2 TexCoord1  : TEXCOORD1; 
};

VpOut20 VS_main20(VpIn20 IN)
{
	VpOut20 OUT;
	OUT.HPos = mul(mul(IN.Pos,PI_mW), C_VP);

	float2 vTexCoords=IN.TexCoord0.xy;

	OUT.HPos.y = -OUT.HPos.y;
	OUT.TexCoord0 = (OUT.HPos.xy + OUT.HPos.w)*0.5/OUT.HPos.w;
	OUT.TexCoord1 = (OUT.HPos.xy + OUT.HPos.w)*0.5/OUT.HPos.w;
	OUT.HPos.y = -OUT.HPos.y;

	return OUT;
}

float4 PS_main20(VpOut20 IN) : COLOR
{
	float4 vRefraction = 	tex2D(ColorSampler,IN.TexCoord0.xy);
	float4 vReflection = 	tex2D(SecondColorSampler,IN.TexCoord1.xy);
	float4 fragment = vRefraction*0.5+vReflection*0.7;
	return fragment;
}

technique ps20 < string name = "Material for glass."; >
{
	pass p0 
	{
		VertexShader = compile VS_SHADER_TYPE VS_main20();
		PixelShader = compile PS_SHADER_TYPE PS_main20();
		DEFAULT_STATES
	}
}

