#define fragInput vertexOutput
#define FRAG_CUSTOM_END
#define LOW_SPEC_CUSTOM_LLIGHTING
#define NO_LIGHTING
  
#include "VertexDef.fxh"

#if RT_PROFILE <= QUALITY_LOW
void LowSpecLighting(inout vertexOutput Out, const in VS_IN In, const float3 vWorldPos, const float3 vWorldNormal, int nType)
{
#if RT_PROFILE == QUALITY_LOW
  Out.Diffuse.rgb = 1.f;
  Out.Diffuse.a = 1.f;
 #if defined(VERTEX_COLOR)
  Out.Diffuse.rgb *= In.VtxColor.rgb;
  Out.Diffuse.a = In.VtxColor.a;
 #endif
  //Out.Diffuse.rgb *= materialColor.rgb;
#elif RT_PROFILE == QUALITY_VERYLOW
  Out.Diffuse = float4(0.95,0.95,0.95,0) + PI_WColor;
#endif	
}
#endif

#include "transform.fxh"
#include "fragDef.fxh"

void frag_custom_per_light(inout fragPass pPass, inout fragLightPass pLight)
{
}

void frag_custom_end(inout fragPass pPass, inout FIXED3 cFinal)
{

  half3 cDiffuse = pPass.cDiffuseMap.rgb * materialColor.rgb
#if defined(RT_LIGHTMAP) && !defined(RT_PLANAR_LIGHTMAP)
	// * tex2D(LightMapSampler, pPass.IN.Tex1)
#endif  
	#if RT_PROFILE > QUALITY_LOW
		* pPass.cVertexColor.rgb
	#else
			* pPass.cDiffuseAcc.rgb
	#endif
		;

  cFinal.rgb += cDiffuse;

 #if defined (RT_GLOW)
  // for glowing objects
  cFinal.xyz *= pPass.fAlpha;
 #endif

#ifdef RT_FRESNEL
	// affect specular by a Fresnel term
	if( pPass.nQuality > QUALITY_MEDIUM )
		pPass.fAlpha *= GetFresnel(pPass.fNdotE, pPass.nQuality, true);
#endif
}

#include "fragLib.fxh"

half4 PS_NoLighting(in fragInput IN) : COLOR
{
  fragPass pPass;
#ifndef OPENGL
  pPass = (fragPass)0;
#endif

  frag_unify(pPass, IN);  
  half4 cFinal = frag_shared_output(pPass);
	return cFinal;
}

technique NoLighting < string name = "Material without lighting. Used for special game effects."; >
{
  pass p0
  {
    VertexShader = compile VS_SHADER_TYPE UberVS();
    PixelShader = compile PS_SHADER_TYPE PS_NoLighting();
		DEFAULT_STATES
  }
}
