#define fragInput vertexOutput
#define RT_TEX_SCROLL
#define FRAG_CUSTOM_END
#define USE_SCREENCOORDS

#include "transform.fxh"
#include "fragDef.fxh"

void frag_custom_per_light(inout fragPass pPass, inout fragLightPass pLight)
{
}

void frag_custom_end(inout fragPass pPass, inout FIXED3 cFinal)
{
  half3 cDiffuse = pPass.cDiffuseMap.xyz * pPass.cVertexColor.rgb;
	cDiffuse *= materialColor.rgb;

	// refraction
#if RT_PROFILE > QUALITY_LOW
	half2 vTexCoord = pPass.IN.ScreenCoordProj.xy / pPass.IN.ScreenCoordProj.z;

#if defined(BUMP_DIFFUSE)
	half2 vDisplacement = tex2D(SpecularSampler, pPass.IN.Tex0).rg * 2.h - 1.h;
#else
	half2 vDisplacement = (half2(sin(pPass.IN.WorldPos.x * 15.f + F_Time.x * 2.5f), cos(pPass.IN.WorldPos.y * 28.f - F_Time.x * 1.7f))) * .01f;
#endif
	vTexCoord += vDisplacement;

	half3 vRefraction = tex2D(BackBufferSampler, vTexCoord);

	cDiffuse = lerp(vRefraction, cDiffuse, pPass.fAlpha);
#endif

  cFinal.rgb += cDiffuse;

#if RT_PROFILE > QUALITY_VERYLOW  // disable fog for blending
 #if defined(RT_FOG) && defined(SM_30)	// diable fog for blending
  pPass.IN.FogColor.xyz = 0;
  cFinal.rgb *= pPass.IN.FogColor.a;
  pPass.IN.FogColor.a = 1.h;
 #endif
#endif
}

#include "fragLib.fxh"

half4 PS_StillWater(in fragInput IN) : COLOR
{
  // Initialize fragPass structure
  fragPass pPass;
#ifndef OPENGL
  pPass = (fragPass)0;
#endif
  frag_unify(pPass, IN);  
  half4 cFinal = frag_shared_output(pPass);
  //cFinal.w = fOpacity;
	return cFinal;
}

technique StillWater < string name = "Material still water."; >
{
  pass p0
  {
    VertexShader = compile VS_SHADER_TYPE UberVS();
    PixelShader = compile PS_SHADER_TYPE PS_StillWater();
		DEFAULT_STATES
  }
}
