/*

	Shadow map techniques

*/

#include "constants.fxh"

float  fScale = 5.0f;

//------------------------------------

sampler2D ZMapSampler = sampler_state 
{
    texture = <Texture0>;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};
sampler2D NMapSampler = sampler_state 
{
    texture = <Texture0>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = None;
    AddressU = Clamp;
    AddressV = Clamp;
};


struct vs_in {
	float3 Pos: POSITION;
};

struct vs_in_show {
	float3 Pos: POSITION;
	float2 Tex0: TEXCOORD0;
};


struct vs_out {
	float4 Pos: POSITION;
	float2  Tex0: TEXCOORD0;
};

/*
struct vs_out_show {
	float4 Pos: POSITION;
	float  Tex0: TEXCOORD0;
};
*/

vs_out VSShowMap(vs_in_show In)
{
  vs_out Out;
  Out.Pos = float4(In.Pos,1);
#ifdef OPENGL
  Out.Pos.xy = ((Out.Pos.xy+float2(0.5, 0.5)) * F_ScreenSize.xy) * 2.f - 1.f;
  Out.Pos.y = -Out.Pos.y;
#endif
  Out.Tex0 = In.Tex0;
  return Out;
}

float4 PSShowZMap(vs_out In): COLOR
{
	float4 Col = tex2D(ZMapSampler, In.Tex0);
	
	return float4(Col.x, Col.x, Col.x, 1);
	//return float4(1,1,1,1);

}
float4 PSShowNMap(vs_out In): COLOR
{
	float4 Col = tex2D(NMapSampler, In.Tex0);
	
	return Col;
}

technique ZShow
{
  pass p0 
  {		
		VertexShader = compile VS_SHADER_TYPE VSShowMap();
		PixelShader  = compile PS_SHADER_TYPE PSShowZMap();
	}
}

technique NShow
{
  pass p0 
  {		
		VertexShader = compile VS_SHADER_TYPE VSShowMap();
		PixelShader  = compile PS_SHADER_TYPE PSShowNMap();
	}
}
