#include "constants.fxh"

#define MAX_BILLBOARDUVS 40
float4x4 gBillboardUvs [MAX_BILLBOARDUVS] ;
float4   vImageOffset;

//------------------------------------
void VS_TransformDiffuse(   in  float4 vInPos  : POSITION,
                            in  float2 vInUv   : TEXCOORD0,
                            out float4 vPos    : POSITION,
                            out float2 vUv     : TEXCOORD0,
                            out float4 vColor  : COLOR)
{
    float4 w0norm = normalize(PI_mW[0]);
    float scale = PI_mW._11/w0norm.x;
  
    float4 vPivotPos = {0,0,0,1};
    vPos = mul(mul( vPivotPos, PI_mW), C_V);
    float4 offset = float4(vInPos.x, vInPos.y, 0, 0);
    vPos = mul(vPos + offset * scale, mP);
    vColor = 1;
   
    int i = int(vInUv.x + vImageOffset.x);
    vUv = gBillboardUvs[i]._m00_m01;
}

//-----------------------------------
technique Default
{
    pass p0 
    {		
		VertexShader = compile VS_SHADER_TYPE VS_TransformDiffuse();
		
		Texture[0] = <Texture0>;
		// Just use the color


		ColorArg1[0] = Diffuse;
		ColorArg2[0] = Texture;
		AlphaArg1[0] = Diffuse;
		AlphaArg2[0] = Texture;
		ColorOp[0] = SelectArg2;
		AlphaOp[0] = SelectArg2;
		ColorOp[1] = Disable;
		AlphaOp[1] = Disable;

	
		
		
    }
}