
#define FLOATTYPE float
#define FLOATTYPE2 float2
#define FLOATTYPE3 float3
#define FLOATTYPE4 float4
#define FLOATTYPE4x4 float4x4

FLOATTYPE4 vStartShadows = {0.0f, 3.0f, 9.0f, 27.0f};
FLOATTYPE  fShadowsFadeDist;

#include "constants.fxh"

FLOATTYPE4x4 mShadowWLP0: ViewLightProjection;
FLOATTYPE4x4 mShadowWLP1: ViewLightProjection;
FLOATTYPE4x4 mShadowWLP2: ViewLightProjection;
FLOATTYPE4x4 mShadowWLP3: ViewLightProjection;

texture Texture3;
texture Texture4;

#define fCosTheta 0.0f
#define SMAP_SIZE 1024
#define SHADOW_EPSILON 0.00005f
#define SHADOW_EPSILON_COMP 0.00004f

#define USE_4_SHADOW_SAMPLES

FLOATTYPE2  g_vSampleOffsets[15];
FLOATTYPE   g_fSampleWeights[15];


sampler2D g_samScene =sampler_state
{
    Texture = <Texture0>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;

};
sampler2D g_samSpot =sampler_state
{
    Texture = <Texture1>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
    AddressU = Clamp;
    AddressV = Clamp;
    
};

sampler2D g_samSpot2 =sampler_state
{
    Texture = <Texture2>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler2D g_samSpot3 =sampler_state
{
    Texture = <Texture3>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
    AddressU = Clamp;
    AddressV = Clamp;
};

sampler2D g_samSpot4 =sampler_state
{
    Texture = <Texture4>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
    AddressU = Clamp;
    AddressV = Clamp;
};


sampler2D g_samSceneBorder =sampler_state
{
    Texture = <Texture0>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
    
};

sampler2D g_samSceneBorderLinear =sampler_state
{
    Texture = <Texture0>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
    
};

sampler2D g_samSceneBorderLinear1 =sampler_state
{
    Texture = <Texture1>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
    
};

sampler2D g_samSceneBorder1 =sampler_state
{
    Texture = <Texture1>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
};


sampler2D g_samSceneBorder2 = sampler_state
{
    Texture = <Texture2>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
};

sampler2D g_samSceneBorder3 = sampler_state
{
    Texture = <Texture3>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = POINT;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
};

sampler2D g_samShadow = sampler_state
{
    Texture = <Texture1>;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
    AddressU = Border;
    AddressV = Border;
    BORDERCOLOR = 0xFFFFFFFF;
};

void VertSceneOnlyShadow3Sun( FLOATTYPE4 iPos : POSITION,
                out FLOATTYPE4 Pos : POSITION,
                out FLOATTYPE4 oPos : TEXCOORD0,
                out FLOATTYPE4 vPos : TEXCOORD1,
                out FLOATTYPE4 oPos2 : TEXCOORD2,
                out FLOATTYPE4 oPos3 : TEXCOORD3
                )
{
    Pos = mul(mul( float4(iPos.xyz,1), PI_mW ), C_VP);
    oPos = mul( float4(iPos.xyz,1), mShadowWLP0 );
    oPos2 = mul( float4(iPos.xyz,1), mShadowWLP1 );
    oPos3 = mul( float4(iPos.xyz,1), mShadowWLP2 );
    float vDist = length(C_Eye - mul(iPos, PI_mW));
    vPos.xyzw = vDist;
}


FLOATTYPE4 PixSceneOnlyShadow3Sun( FLOATTYPE4 vPos : TEXCOORD0, FLOATTYPE4 vPosView : TEXCOORD1, FLOATTYPE4 vPos1 : TEXCOORD2,
    FLOATTYPE4 vPos2 : TEXCOORD3) :COLOR
{
    FLOATTYPE Diffuse[3];
	FLOATTYPE Zmain;    
	
    {
		FLOATTYPE2 ShadowTexC = vPos.xy / vPos.w;// + FLOATTYPE2( 0.5, 0.5 );
        FLOATTYPE Offset =  vPos.w/SMAP_SIZE;

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos.z / vPos.w + SHADOW_EPSILON;
        
			
		sourcevals[0] = ((tex2Dproj( g_samSceneBorder, vPos)) < Z )? 0.0f: 1.0f;  
#ifdef USE_4_SHADOW_SAMPLES        
        sourcevals[1] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
        sourcevals[2] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
        sourcevals[3] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
#endif        
        // lerp between the shadow values to calculate our light amount
#ifdef USE_4_SHADOW_SAMPLES               
        FLOATTYPE LightAmount = (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
#else
		FLOATTYPE LightAmount = sourcevals[0];
#endif		

		Diffuse[0] = LightAmount;
	  }


    {

		FLOATTYPE2 ShadowTexC = vPos1.xy / vPos1.w + 0.1f;// + FLOATTYPE2( 0.5, 0.5 );
        FLOATTYPE Offset =  vPos1.w/SMAP_SIZE;
     

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos1.z / vPos1.w + SHADOW_EPSILON;
        {
        sourcevals[0] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
#ifdef USE_4_SHADOW_SAMPLES        
        sourcevals[1] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
        sourcevals[2] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
        sourcevals[3] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
#endif        
        // lerp between the shadow values to calculate our light amount
#ifdef USE_4_SHADOW_SAMPLES               

        FLOATTYPE LightAmount = (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
#else
		FLOATTYPE LightAmount = sourcevals[0];
#endif		

		Diffuse[1] = LightAmount;
		
		  }
		}


    {

        FLOATTYPE Offset =  vPos2.w/SMAP_SIZE;
     

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos2.z / vPos2.w + SHADOW_EPSILON;
        {
        sourcevals[0] = ((tex2Dproj( g_samSceneBorder2, vPos2 ).r ) < Z)? 0.0f: 1.0f;  
        // lerp between the shadow values to calculate our light amount
		FLOATTYPE LightAmount = sourcevals[0];

		Diffuse[2] = LightAmount;
		
		  }
		}


		FLOATTYPE4 bLod = vStartShadows < vPosView;
		float iMapToUse = dot(bLod, 1.0f);
		return half4(saturate(F_WorldAmbient.xyz + Diffuse[iMapToUse-1]), 1);
}




void VertSceneOnlyShadow4Sun( FLOATTYPE4 iPos : POSITION,
                out FLOATTYPE4 Pos : POSITION,
                out FLOATTYPE4 oPos : TEXCOORD0,
                out FLOATTYPE4 vPos : TEXCOORD1,
                out FLOATTYPE4 oPos2 : TEXCOORD2,
                out FLOATTYPE4 oPos3 : TEXCOORD3,
                out FLOATTYPE4 oPos4 : TEXCOORD4
                )
{
    //
    // Transform position to view space
    //
    
    Pos = mul(mul( float4(iPos.xyz,1), PI_mW ), C_VP);

    //
    // Transform to screen coord
    //
    oPos = mul( float4(iPos.xyz,1), mShadowWLP0 );
    oPos2 = mul( float4(iPos.xyz,1), mShadowWLP1 );
    oPos3 = mul( float4(iPos.xyz,1), mShadowWLP2 );
    oPos4 = mul( float4(iPos.xyz,1), mShadowWLP3 );
    

    //
    // Transform the position to light projection space, or the
    // projection space as if the camera is looking out from
    // the spotlight.
    //
    
    float vDist = length(mul(mul(iPos, PI_mW), C_V));
    vPos.xyzw = vDist;
}

// FLOATTYPE SetShadowSampler9(FLOATTYPE4 vPos, sampler2D g_samSceneBorder )
// {
//     FLOATTYPE sourcevals[9];
//     FLOATTYPE Z = vPos.z / vPos.w;// + SHADOW_EPSILON;
// 	FLOATTYPE Offset =  vPos.w/SMAP_SIZE;        
// 	
// 	sourcevals[0] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, 0,0,0) )) < Z )? 0.0f: 1.0f;  
//     sourcevals[1] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
//     sourcevals[2] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
//     sourcevals[3] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
//     sourcevals[4] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(-Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
//     sourcevals[5] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, -Offset,0,0) )) < Z)? 0.0f: 1.0f;  
//     sourcevals[6] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(-Offset, -Offset,0,0) )) < Z)? 0.0f: 1.0f;  
//     sourcevals[7] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(-Offset, Offset,0,0) )) < Z )? 0.0f: 1.0f;  
//     sourcevals[8] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, -Offset,0,0) )) < Z)? 0.0f: 1.0f;  
// 
// 
//    	return (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3] +
// 	sourcevals[4]+sourcevals[5]+sourcevals[6]+sourcevals[7] + sourcevals[8])/9.0f;
// }


FLOATTYPE SetShadowSampler9(FLOATTYPE4 vPos, sampler2D g_samSceneBorder )
{
    FLOATTYPE sourcevals[4];
    //vPos.xy / = vPos.z;
    
    FLOATTYPE Z = vPos.z / vPos.w;// + SHADOW_EPSILON;
	FLOATTYPE Offset =  vPos.w/SMAP_SIZE;        
	
	sourcevals[0] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, 0,0,0) )) < Z )? 0.0f: 1.0f;  
    sourcevals[1] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
    sourcevals[2] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
    sourcevals[3] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  

   	return (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
}

FLOATTYPE4 PixSceneOnlyShadow4Sun( FLOATTYPE4 vPos : TEXCOORD0, FLOATTYPE4 vPosView : TEXCOORD1, FLOATTYPE4 vPos1 : TEXCOORD2,
    FLOATTYPE4 vPos2 : TEXCOORD3,FLOATTYPE4 vPos3 : TEXCOORD4) :COLOR
{
    FLOATTYPE Diffuse[4];
	FLOATTYPE Zmain;    
	
	Diffuse[0] = SetShadowSampler9(vPos, g_samSceneBorder);
	Diffuse[1] = SetShadowSampler9(vPos1, g_samSceneBorder1);
	Diffuse[2] = SetShadowSampler9(vPos2, g_samSceneBorder2);
	Diffuse[3] = SetShadowSampler9(vPos3, g_samSceneBorder3);
	  
	float4 bLOD;
	
	float iMapToUse = 3;
	float4 sm0usage;
	sm0usage.xy = vPos.xy/vPos.w;   
	sm0usage.zw = 1 - sm0usage.xy;
	//bLOD.x = saturate(dot(float4(sm0usage < 0.05f), float4(1,1,1,1)));

	float4 sm1usage;
	sm1usage.xy = vPos1.xy/vPos1.w;   
	sm1usage.zw = 1 - sm1usage.xy;

	float4 sm2usage;
	sm2usage.xy = vPos2.xy/vPos2.w;   
	sm2usage.zw = 1 - sm2usage.xy;
	
	if (dot(float4(sm0usage > 0.05f), float4(1,1,1,1)) == 4)
	{
		iMapToUse = 0;
	}
	else
		if (dot(float4(sm1usage > 0.05f), float4(1,1,1,1)) == 4)
		{
			iMapToUse = 1;	
		}
		else
			if (dot(float4(sm2usage > 0.05f), float4(1,1,1,1)) == 4)
			{
				iMapToUse = 2;
			}
	
//	bLOD.y = saturate(dot(float4(sm1usage < 0.05f), float4(1,1,1,1)));
//	bLOD.z = saturate(dot(float4(sm2usage < 0.05f), float4(1,1,1,1)));
//	float4 sm3usage;
//	sm3usage.xy = vPos3.xy/vPos3.w;   
//	sm3usage.zw = 1 - sm3usage.xy;
//	bLOD.w = 0;//saturate(dot(float4(sm3usage < 0.05f), float4(1,1,1,1)));
//

//	FLOATTYPE4 bLod = vStartShadows < vPosView;
	//float iMapToUse = dot(bLOD, 1.0f);
	
	//iMapToUse = 0;

	float final = Diffuse[iMapToUse];// < 1.0f ? saturate((vPosView - vStartShadows.w) * fShadowsFadeDist) : 1.0f;
	return half4(saturate(F_WorldAmbient.xyz + final), 1);// dot(bLod, 1.0f) / 6 +  1 - tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, 0,0,0) );///saturate(vWorldAmbient + Diffuse[iMapToUse-1] + final); // fShadowsFadeDist
}


void VertSceneOnlyShadow2Sun( FLOATTYPE4 iPos : POSITION,
                out FLOATTYPE4 Pos : POSITION,
                out FLOATTYPE4 oPos : TEXCOORD0,
                out FLOATTYPE4 vPos : TEXCOORD1,
                out FLOATTYPE4 oPos2 : TEXCOORD2)
{
    Pos = mul(mul( float4(iPos.xyz,1), PI_mW ), C_VP);
    oPos = mul( float4(iPos.xyz,1), mShadowWLP0 );
    oPos2 = mul( float4(iPos.xyz,1), mShadowWLP1 );
    float vDist = length(C_Eye - mul(iPos, PI_mW));
    vPos.xyzw = vDist;

}



FLOATTYPE4 PixSceneOnlyShadow2Sun( FLOATTYPE4 vPos : TEXCOORD0, FLOATTYPE4 vPosView : TEXCOORD1, FLOATTYPE4 vPos1 : TEXCOORD2) :COLOR
{
    FLOATTYPE Diffuse[2];
	FLOATTYPE Zmain;    
    {


		FLOATTYPE2 ShadowTexC = vPos.xy / vPos.w;// + FLOATTYPE2( 0.5, 0.5 );
		
        FLOATTYPE Offset =  vPos.w/SMAP_SIZE;
     

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos.z / vPos.w + SHADOW_EPSILON;
        Zmain = vPosView.z / vPosView.w;
        
        if (tex2Dproj( g_samSceneBorder, vPos ).r < Z)
			sourcevals[0] = 0.0f;
		else
			sourcevals[0] = 1.0f;	
			

#ifdef USE_4_SHADOW_SAMPLES        
        sourcevals[1] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
        sourcevals[2] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
        sourcevals[3] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
#endif        
        // lerp between the shadow values to calculate our light amount
#ifdef USE_4_SHADOW_SAMPLES               
        FLOATTYPE LightAmount = (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
#else
		FLOATTYPE LightAmount = sourcevals[0];
#endif		

		Diffuse[0] = saturate(LightAmount + F_WorldAmbient.xyz);
		
		  }

FLOATTYPE4 Diffuse1;

    {

		FLOATTYPE2 ShadowTexC = vPos1.xy / vPos1.w + 0.1f;// + FLOATTYPE2( 0.5, 0.5 );
        FLOATTYPE Offset =  vPos1.w/SMAP_SIZE;
     

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos1.z / vPos1.w + SHADOW_EPSILON;
        {
        sourcevals[0] = ((tex2Dproj( g_samSceneBorder1, vPos1 ).r ) < Z)? 0.0f: 1.0f;  
#ifdef USE_4_SHADOW_SAMPLES        
        sourcevals[1] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
        sourcevals[2] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
        sourcevals[3] = ((tex2Dproj( g_samSceneBorder1, vPos1 + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
#endif        
        // lerp between the shadow values to calculate our light amount
#ifdef USE_4_SHADOW_SAMPLES               
        FLOATTYPE LightAmount = (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
#else
		FLOATTYPE LightAmount = sourcevals[0];
#endif		

		Diffuse[1] = saturate(LightAmount +  F_WorldAmbient.xyz);
		
		  }
		}

		FLOATTYPE4 bLod = vStartShadows < vPosView;
		float iMapToUse = dot(bLod, 1.0f);
	
		return half4(saturate(F_WorldAmbient.xyz + Diffuse[iMapToUse-1]), 1);


}

void VertSceneOnlyShadow1Sun( FLOATTYPE4 iPos : POSITION,
                out FLOATTYPE4 Pos : POSITION,
                out FLOATTYPE4 oPos : TEXCOORD0,
                out FLOATTYPE4 vPos : TEXCOORD1)
{
    Pos = mul(mul( float4(iPos.xyz,1), PI_mW ), C_VP);
    oPos = mul( float4(iPos.xyz,1), mShadowWLP0 );
    float vDist = length(C_Eye - mul(iPos, PI_mW));
    vPos.xyzw = vDist;

}



FLOATTYPE4 PixSceneOnlyShadow1Sun( FLOATTYPE4 vPos : TEXCOORD0, FLOATTYPE4 vPosView : TEXCOORD1) :COLOR
{
    FLOATTYPE Diffuse[2];
	FLOATTYPE Zmain;    
    {


		FLOATTYPE2 ShadowTexC = vPos.xy / vPos.w;// + FLOATTYPE2( 0.5, 0.5 );
		
        FLOATTYPE Offset =  vPos.w/SMAP_SIZE;
     

        FLOATTYPE sourcevals[4];
        FLOATTYPE Z = vPos.z / vPos.w + SHADOW_EPSILON;
        Zmain = vPosView.z / vPosView.w;
        
        if (tex2Dproj( g_samSceneBorder, vPos ).r < Z)
			sourcevals[0] = 0.0f;
		else
			sourcevals[0] = 1.0f;	
			

#ifdef USE_4_SHADOW_SAMPLES        
        sourcevals[1] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, 0,0,0) )) < Z )? 0.0f: 1.0f;  
        sourcevals[2] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(0, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
        sourcevals[3] = ((tex2Dproj( g_samSceneBorder, vPos + FLOATTYPE4(Offset, Offset,0,0) )) < Z)? 0.0f: 1.0f;  
#endif        
        // lerp between the shadow values to calculate our light amount
#ifdef USE_4_SHADOW_SAMPLES               
        FLOATTYPE LightAmount = (sourcevals[0]+sourcevals[1]+sourcevals[2]+sourcevals[3])/4.0f;
#else
		FLOATTYPE LightAmount = sourcevals[0];
#endif		

		Diffuse[0] = saturate(LightAmount + F_WorldAmbient.xyz);
		
		  }

	
		return half4(saturate(F_WorldAmbient.xyz + Diffuse[0]), 1);


}


technique OnlyShadowGSM1
{
    pass p0
    {
        VertexShader = compile VS_SHADER_TYPE VertSceneOnlyShadow1Sun();
        PixelShader = compile PS_SHADER_TYPE PixSceneOnlyShadow1Sun();
    }
   
}

technique OnlyShadowGSM2
{
    pass p0
    {
        VertexShader = compile VS_SHADER_TYPE VertSceneOnlyShadow2Sun();
        PixelShader = compile PS_SHADER_TYPE PixSceneOnlyShadow2Sun();
    }
   
}

technique OnlyShadowGSM3
{
    pass p0
    {
        VertexShader = compile VS_SHADER_TYPE VertSceneOnlyShadow3Sun();
        PixelShader = compile PS_SHADER_TYPE PixSceneOnlyShadow3Sun();
    }
   
}


technique OnlyShadowGSM4
{
    pass p0
    {
        VertexShader = compile VS_SHADER_TYPE VertSceneOnlyShadow4Sun();
        PixelShader = compile PS_SHADER_TYPE PixSceneOnlyShadow4Sun();
    }
   
}
