
#if defined(BEND_TREE)
float3 BendVeg(inout VS_IN In)
{
  float3 Pbend = In.Position.xyz;
  float L = length(Pbend);
  float bendAmount = Pbend.y*Pbend.y*maxBend;
#ifdef VERTEX_COLOR
	bendAmount *= In.VtxColor.a;
	In.VtxColor.a = 1.f;
#endif
//      
//----------------------------------------------
//  const float freqA = 10.0;
  const float freqA = 0.5;
  float freq = (fmod(Pbend.x, 2) * 1.6 + fmod(Pbend.z, 2) * 1.4)*freqA;
  float phase = F_Time.x * freq - Pbend.y*rcpBend;
  Pbend += windParam.xyz * (sin(phase) ) * windParam.w * bendAmount;//+ sin(F_Time.x*31.7f + Pbend.x) * 0.2
  return normalize(Pbend)*L;
}

#elif defined(BEND_LOCAL)
float3 BendVegLocal(const in VS_IN In)
{
  float3 Pbend = In.Position.xyz - In.Tex1;
  float L = length(Pbend);
  float bendAmount = L*L*maxBend;
  float phase = F_Time.x - L*rcpBend;
  Pbend += windParam.xyz * (sin(phase) ) * windParam.w * bendAmount * (1.0 - abs(dot(windParam.xyz, In.Tex2)));
  return normalize(Pbend)*L + In.Tex1;
}

#elif defined(BEND_GRASS)
float3 BendGrass(in VS_IN In, const in float2 Pw) 
{
  float3 Pbend = In.Position.xyz;
  float L = length(Pbend);
#ifdef VERTEX_COLOR  
	float bendAmount = In.VtxColor.a;
	In.VtxColor.a = 1.f;
#else
    float bendAmount = Pbend.y*maxBend*32;
#endif
  float phase = (F_Time.x + Pbend.y*0.41)*1.7 + Pw.x + Pw.y;
  Pbend += windParam.xyz * sin(phase) * windParam.w * bendAmount;
  Pbend = normalize(Pbend)*L;
  return Pbend;
}
#endif
