#include "constants.fxh"

struct a2v {
	float3 Position : POSITION; //in object space
	float3 Normal : NORMAL; //in object space
	float2 TexCoord0 : TEXCOORD0;
};

struct v2f {
	float4 Position : POSITION; //in projection space
	float2 TexCoord0 : TEXCOORD0;
	float2 TexCoord1 : TEXCOORD1;
	float4 Fog: TEXCOORD2;
};

float waveSpeed = 0.34f;
float noiseSpeed = 0.18f;

static float cHalf = 0.5f;
/////////////////////// vertex shader ///////

v2f DiffuseBumpVS1(a2v IN)
{
	v2f OUT;
	float4 vProjPos= mul(mul(float4(IN.Position,1.0f), PI_mW), C_VP);
	OUT.Position = vProjPos;
	OUT.TexCoord1 = IN.TexCoord0;
	OUT.TexCoord0 = IN.TexCoord0 + float2(F_Time.x.x*0.01f, 0.0f);

	float dist = length(mul(mul(float4(IN.Position,1.0f), PI_mW), C_V));
	OUT.Fog.xyzw = (50000.0f - dist) *0.000002f;
	
	return OUT;
}

float4 DiffuseBumpPS(v2f IN):COLOR
{
	float4 Color = tex2D(ColorSampler, IN.TexCoord0) + tex2D(SecondColorSampler,IN.TexCoord1);
	Color.rgba = lerp(float4(0.0, 0.0, 0.0, 1.0f),Color.rgba,IN.Fog.rgba);//Addinscatter
	return  Color;
}
/////////////////////// pixel shader ///////

technique Default
{
	pass p0
	{
		ZEnable = false;
		CullMode = None;

		VertexShader = compile VS_SHADER_TYPE DiffuseBumpVS1();
		PixelShader = compile PS_SHADER_TYPE DiffuseBumpPS();

		AlphaBlendEnable = true;
		SRCBlend = One;
		DestBlend = One;
		DEFAULT_STATES
	}
}
