#include "constants.fxh"

// VS

#if defined (RT_ALPHA_GRADIENT) || defined(RT_DEFERRED) || ((defined(RT_SHADOWS) || defined(RT_SSAO) || defined(USE_SCREENCOORDS)) && RT_PROFILE > QUALITY_LOW)
	// comments in the end it would be: (Out.Pos.xy / Out.Pos.w) * float2(.5f, -.5f) + float2(.5f, .5f) + float2(.5f, .5f) / F_ScreenSize
 #ifdef OPENGL
#define    GEN_SHADOW_COORD	Out.ScreenCoordProj = Out.HPosition.xyw; \
														Out.ScreenCoordProj.xy = Out.ScreenCoordProj.xy * float2(.5f, .5f) + (float2(.5f, .5f) + float2(.5f, .5f) * F_ScreenSize.xy) * Out.HPosition.w; 
 #else
#define    GEN_SHADOW_COORD	Out.ScreenCoordProj = Out.HPosition.xyw; \
														Out.ScreenCoordProj.xy = Out.ScreenCoordProj.xy * float2(.5f, -.5f) + (float2(.5f, .5f) + float2(.5f, .5f) * F_ScreenSize.xy) * Out.HPosition.w;
 #endif

#else
#define    GEN_SHADOW_COORD
#endif

#if defined(RT_SHADOWS) || defined(RT_SSAO)
#define ApplyLighting(cDiffuse, cLighting, ScreenCoordProj) __ApplyLighting(cDiffuse, cLighting, ScreenCoordProj)

half3 __ApplyLighting(const in half3 cDiffuse, const in half3 cLighting, const in float3 ScreenCoordProj) 
{
 	half3 cAmbient = F_WorldAmbient.rgb; 
	float4 shadowing = tex2Dproj(ShadowMaskSampler, ScreenCoordProj.xyzz); 
#ifdef RT_SSAO 
	cAmbient *= shadowing.a; 
#endif 
	return (cAmbient + cLighting * shadowing.r) * cDiffuse; 
}

#else
#define ApplyLighting(cDiffuse, cLighting, ScreenCoordProj)  __ApplyLighting(cDiffuse, cLighting)

half3 __ApplyLighting(const in half3 cDiffuse, const in half3 cLighting) 
{
	return (F_WorldAmbient.rgb + cLighting) * cDiffuse; 
}

#endif