#include "constants.fxh"
//--------------------------------------
//
float4 Offset;
float fScale : FTILESCALE = 7.0f;
float cTileScale = 0.39f;
//--------------------------------------

sampler2D Sampler0Land = sampler_state {
	Texture = <Texture0>;
	minfilter = linear;
	magfilter = linear;
	mipfilter = linear;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

struct VSOUTPUT
{
	float4 Pos : POSITION;
	float2 Texcoord0 : TEXCOORD0;
	float2 Texcoord1 : TEXCOORD1;
	float2 Texcoord2 : TEXCOORD2;
	float2 Texcoord3 : TEXCOORD3;
};

VSOUTPUT VSBake(float4 vPos:POSITION,float2 vTex0: TEXCOORD0)
{
	VSOUTPUT Out;
	
	Out.Pos = vPos;
	Out.Texcoord0 = vTex0;
	Out.Texcoord1 = (Offset.xy /32.0f + vTex0) * fScale;//, vPos.xz*0.5f
// Out.Texcoord1=(Offset.xy /32.0f + vTex0) * cTileScale;  
// Out.Texcoord1=float4(vTex0, vPos.xz*0.5f);  

	Out.Texcoord3 = Out.Texcoord1;//* fScale
	Out.Texcoord2 = Out.Texcoord1;//* fScale
	//Out.Texcoord1 = Out.Texcoord1;//* fScale

	return Out;
}

//PS
half4 PSBake(VSOUTPUT In):COLOR
{
	half4  mask = tex2D(Sampler0Land, In.Texcoord0);
	half4  col1 = tex2D(SecondColorSampler, In.Texcoord1 );
	half4  col2 = tex2D(ThirdColorSampler, In.Texcoord2 );
	half4  col3 = tex2D(FourthColorSampler, In.Texcoord3 );
	half4 Color = col1*mask.r + col2*mask.g + col3*mask.b;
	Color.a=1.0f;
	return Color;
}

technique Default
{
	pass P0
	{
		VertexShader = compile VS_SHADER_TYPE VSBake();
		PixelShader = compile PS_SHADER_TYPE PSBake();
	}
}
