// Scattering


texture Texture0 : TEXTURE0;
texture Texture1 : TEXTURE1;
texture Texture2 : TEXTURE2;
texture Texture3 : TEXTURE3;
texture Texture4 : TEXTURE4;
texture Texture5 : TEXTURE5;
texture Texture6 : TEXTURE6;
texture Texture7 : TEXTURE7;
texture Texture8 : TEXTURE8;
texture Texture9 : TEXTURE9;
texture Texture10 : TEXTURE10;

texture DetailTexture : TEXTURE1;
texture NormalTexture : TEXTURE2;


float4 Offset;

//
//--------------------------------------
float fScale : FTILESCALE = 7.0f;
float cTileScale = 0.39f;
//--------------------------------------

sampler Sampler0Land =
	sampler_state {
		Texture = <Texture0>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = CLAMP;
	AddressV = CLAMP;
		
    };

sampler Sampler0 =
	sampler_state {
		Texture = <Texture0>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler1 =
    sampler_state {
		Texture = <Texture1>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler2 =
    sampler_state {
		Texture = <Texture2>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler3 =
	sampler_state {
		Texture = <Texture3>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler4 =
    sampler_state {
		Texture = <Texture4>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
    
sampler Sampler5 =
    sampler_state {
		Texture = <Texture5>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler6 =
    sampler_state {
		Texture = <Texture6>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler7 =
	sampler_state {
		Texture = <Texture7>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler8 =
    sampler_state {
		Texture = <Texture8>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler9 =
    sampler_state {
		Texture = <Texture9>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };
sampler Sampler10 =
    sampler_state {
		Texture = <Texture10>;
		minfilter = linear;
		magfilter = linear;
		mipfilter = linear;
	AddressU = WRAP;
	AddressV = WRAP;
		
    };


float4 vConstants={1.0f,-1.4426950f,-0.00005f,0.1f};//constants
struct VSOUTPUT
{
	float4 Pos : POSITION;
	float2 Texcoord0 : TEXCOORD0;
	float2 Texcoord1 : TEXCOORD1;
};


struct VS_INPUT
{
    float4 Pos  : POSITION;
    float2 Tex0  : TEXCOORD0;
};


VSOUTPUT VS(float4 vPos:POSITION,float2 vTex0: TEXCOORD0)
{
	VSOUTPUT Out;
	
	Out.Pos = vPos;
	Out.Texcoord0 = vTex0 ;
	Out.Texcoord1 = (Offset.xy /32.0f + vTex0) * fScale;//, vPos.xz*0.5f
//    Out.Texcoord1=(Offset.xy /32.0f + vTex0) * cTileScale;  
//    Out.Texcoord1=float4(vTex0, vPos.xz*0.5f);  

	return Out;
}



//PS
float4 PSOldTerrain(VSOUTPUT In):COLOR
{
	float4  mask = tex2D(Sampler0Land, In.Texcoord0);
//	float2 tc = frac(In.Texcoord1.xy);
	float2 tc = In.Texcoord1.xy;
	float4  col1 = tex2D(Sampler1, tc );//* fScale
	float4  col2 = tex2D(Sampler2, tc );//* fScale
	float4  col3 = tex2D(Sampler3, tc );//* fScale
	float4  col4 = tex2D(Sampler4, tc );//* fScale
	float4  col5 = tex2D(Sampler5, tc );//* fScale
	float4 Color = col1*mask.r +
	             col2*mask.g +
	             col3*mask.b +
	             col4*mask.a + col5 * (1.0f - (mask.r + mask.g  + mask.b + mask.a)) ;
//	Color.rgb *= In.Extinction.rgb;//Applyextinction
//	Color.rgb += In.Inscatter.rgb;//Addinscatter
	Color.a=1.0f;
//	return float4(tc, 0, 1);
	return Color;
}



technique Default
{
	pass P0
	{
		PixelShader = compile PS_SHADER_TYPE PSOldTerrain();
		VertexShader=compile VS_SHADER_TYPE VS();
	}
}
